<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title>Classic Mayan Numeric Transliteration to TEI</title>
		<meta charset="utf-8"/>
		<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"/>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
		<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
		<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css"/>
		<link href="https://netdna.bootstrapcdn.com/bootstrap/3.0.0/css/bootstrap-glyphicons.css" rel="stylesheet">
		<link rel="stylesheet" href="css/prism.css"/>
		<link rel="stylesheet" href="css/style.css"/>
		<style>
			.modal-xl {
				max-width: 1000px !important;
				align-items: left !important;
			}
			#artefactSearch-modal label {
				justify-content: flex-start;
				margin-left: 20px;
				margin-bottom: 10px;
			}
			#teiParsingResult {
			  width: 800px;
			  height: 500px;
			}

			div.ab-parserResults{
				width: 800px;
				margin: 10px auto;
				font-size: 0.9em;
				margin-left: 200px
			}
			div.block div.boxABresult{
				width: 653px;
				float: left;
				margin-left: 145px;
				display: inline;
				padding: 5px;
				background: #FFFFFF;
				border-left-style: double;
				border-left: 1px solid black;

				/*width: 80%;
				height: 100%;
				box-sizing: border-box;
				border-radius: 0px 15px 15px 0px;
				background: #dfdfdf;
				margin-top: 20px;
				margin-bottom: 20px;
				margin-right: 20px;
				float: right;
				float: left;*/
			}
		/*	div.boxABresult xmp{
				width: 600px;
				height: 100%;
			}*/

			div.block div.blockID{
				float: left;
width: 145px;
padding: 5px;
background: #FFFFFF;
text-align: center;
				/*width: 100px;
				height: 100%;
				float:left;
				padding-right: 0px;
				border-radius: 15px 0px 0px 15px;
				background: #dfdfdf;
				margin-top: 20px;
				margin-bottom: 20px;
				margin-left:20px;
				vertical-align: middle;*/
			}
			.vertical-center {
  margin: 0;
  position: absolute;
  top: 50%;
  -ms-transform: translateY(-50%);
  transform: translateY(-50%);
}
			div.block{
				width: 1000px;
				/*margin: 10px auto;*/
				font-size: 0.9em;
				border: 1px solid black;
				float:left;
				position: relative;
				margin-top: 1px
				/*clear:both;*/
				/*width:100%;
				height: 100%;
				background-color: #6495ED;
				float:left;
				margin-top: 5px;*/

			}
			h2.centerText{
				/*height: 100%;*/
				margin-left: auto;
				margin-right: auto;
				margin-top:auto;
				margin-bottom: auto;
				width: 50px;
				display: inline;
			}
			div.imageSigns{
				width:1000px;
				height:100px;
				border-top: 1px solid black;
				float:left;
				display: inline;
				position: relative;
				padding-left: 400px;
			}
			div.imageSigns div.imageSign{
				width:90px;
				height:100px;
				float:left;
				display: inline;
				margin-top: 20px;
    		margin-bottom: 5px;
			}
			/*html, body { height: 100%; width: 100%; margin: 0; }*/
		</style>

<!-- #div.boxRound{
	width: 80%;
	padding: 20px;
	box-sizing: border-box;
	border-radius: 15px 15px 15px 15px;
	background: #dfdfdf;
	margin-top: 20px;
	margin-bottom: 20px;
}
label.insert {
	left: 0px;
	top: 0px;
	width: 350px;
	
	text-align: left;
	float: left;
	margin: 1px;
}
input[type=text], select {
	width: 100%;
	padding: 12px 20px;
	margin: 8px 0;
	display: inline-block;
	border: 1px solid #ccc;
	border-radius: 4px;
	box-sizing: border-box;
} -->

	</head>
	<body>

		<div class="container-header">
			<div class="container-fluid">
				<h1>Classic Mayan Numeric Transliteration to TEI</h1>
			</div>
		</div>

		<div class="container-content">
			<div class="input-group mb-3">
				<div class="input-group-prepend">
					<span class="input-group-text" id="basic-addon1"></span>
				</div>
				<input id="teiUri" type="text" class="form-control" placeholder="URI of TEI-File" aria-label="teifile" aria-describedby="basic-addon1" value=""/>
				<div class="input-group-append">
					<span class="input-group-text"><img src="/home/max/dev/idiom/teigenerator/src/main/webapp/open-iconic-master/svg/check.svg" alt=""/></span>
				</div>
			</div>
			<input id="sid" type="text" class="form-control" placeholder="SessionID" aria-label="SID" aria-describedby="sid" value=""/>
		</div>

		<!-- div class="container-content">
			<h1>Open allready parsed TEI-File</h1>
			<div class="input-group mb-3">
				<div class="input-group-prepend">
					<span class="input-group-text" id="basic-addon1"></span>
				</div>
				<input id="teiUri" type="text" class="form-control" placeholder="URI of TEI-File" aria-label="teifile" aria-describedby="basic-addon1" value=""/>
				<div class="input-group-append">
					<span class="input-group-text"><img src="/home/max/dev/idiom/teigenerator/src/main/webapp/open-iconic-master/svg/check.svg" alt=""/></span>
				</div>
			</div>		
		</div-->



		<div class="container-artefactSearch">
			<div class="input-group mb-3">
				<div class="input-group-prepend">
					<span class="input-group-text" id="artefact">Artefact</span>
				</div>
				<input id="artefactUri" type="text" class="form-control" placeholder="Artefact" aria-label="Artefact" aria-describedby="artefact" value=""/>
				<div class="input-group-append">
					<button type="button" id="artefactSearch" class="btn btn-default btn-lg" data-toggle="modal" data-target="#crm_P46_is_composed_of">
					  <span class="glyphicon glyphicon-search" aria-hidden="true"></span>
					</button>
				</div>
			</div>
			<div class="input-group mb-3">
				<div class="input-group-prepend">
					<span class="input-group-text" id="teiTItle">Title</span>
				</div>
				<input id="titleOfTEIFile" type="text" class="form-control" placeholder="Title" aria-label="Title" aria-describedby="title" value=""/>
			</div>
			<button id="parsetei" type="button" class="btn btn-dark btn-block">Parse</button>
		</div>

<div class="container-content">
   <div class="container-parserResults">
		 <textarea id="teiParsingResult"></textarea>
	 </div>
</div>
<div class="ab-parserResults"></div>


		<!-- div class="container-content boxRound">
			<form>
				<label class="insert" for="teifile">URI of TEI-File</label>
				<input type="text" id="teiUri" name="uriOfTEIFile" placeholder="textgrid:...">

				<label class="insert" for="artefact">Artefact</label>
				<input type="text" id="artefactUri" name="uriOfArtefact" placeholder="Artefact Name">

				<label class="insert" for="titleOfArtefact">Artefact Title</label>
				<input type="text" id="artefactTitle" name="titleOfArtefact" placeholder="Uxul...">

				<label class="insert" for="sessionIdInTextGrid">SessionID</label>
				<input type="text" id="sid" name="sessionIdInTextGrid" placeholder="Uxul...">
			</form>
		</div-->


  	<!-- Modal -->
		<div class="modal fade" id="artefactSearch-modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
		  <div class="modal-dialog modal-xl">
		    <div class="modal-content">
		      <div class="modal-header">
		        <h2 class="modal-title">Search for Artefacts</h2>
		        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
		          <span aria-hidden="true">&times;</span>
		        </button>
		      </div>
		      <div class="modal-body">
						<form class="form-inline">
							<div class="form-group">
								<label class="sr-only">Artefact</label>
							  <div id="artefactResults" class="form-gorup"></div>
							</div>
						</form>
		      </div>
		      <div class="modal-footer">
		        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
		        <button id="setArtefactURI" type="button" class="btn btn-primary">Choose</button>
		      </div>
		    </div>

		  </div>

		</div>

		<script>
			$(document).on("ready click", "#artefactSearch", function(e) {

				$('#artefactSearch-modal').modal('show')
        queryPrefixes = "prefix dct: <http://purl.org/dc/terms#> prefix dc: <http://purl.org/dc/elements/1.1/> prefix rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> prefix rdfs: <http://www.w3.org/2000/01/rdf-schema#> prefix owl: <http://www.w3.org/2002/07/owl#> prefix xsd: <http://www.w3.org/2001/XMLSchema#> prefix idi: <http://idiom.uni-bonn.de/terms#> prefix idiom: <http://idiom-projekt.de/schema/> prefix ecrm: <http://erlangen-crm.org/current#> prefix edm: <http://www.europeana.eu/schemas/edm#> prefix form: <http://rdd.sub.uni-goettingen.de/rdfform#> prefix crm: <http://erlangen-crm.org/current/> prefix tgforms: <http://www.tgforms.de/terms#> prefix textgrid: <http://textgridrep.de/> prefix schema: <http://schema.org/> prefix skos: <http://www.w3.org/2004/02/skos/core#> prefix wgs84pos: <http://www.w3.org/2003/01/geo/wgs84_pos#> prefix rel: <http://purl.org/vocab/relationship/> prefix edm: <http://www.europeana.eu/schemas/edm/> prefix idiomcat: <http://idiom-projekt.de/catalogue/>";
				artefactQuery = queryPrefixes + ' SELECT (group_concat( distinct ?tgObject;separator="; ") as ?tgObjects) (group_concat( distinct ?prefTitle;separator="; ") as ?prefTitles) (group_concat( distinct ?titleDisp;separator="; ") as ?titleDisps) (group_concat( distinct ?titleType;separator="; ") as ?titleTypes) (group_concat( distinct ?addIdentifierName;separator="; ") as ?addIdentifierNames) (group_concat( distinct ?addIdentifierType;separator="; ") as ?addIdentifierTypes) (group_concat( distinct ?idiomNumber;separator="; ") as ?idiomNumbers) WHERE { GRAPH ?textgridURI { ?tgObject rdf:type idiom:Artefact . ?tgObject idiom:preferredTitle ?prefTitle. FILTER (regex (str(?prefTitle), "' + $("input#artefactUri").val() + '", "i")). OPTIONAL { ?tgObject idiom:identifier ?idiomNumber . } OPTIONAL { ?addIdentifier idiom:noteId ?addIdentifierName . ?addIdentifier idiom:identifierType ?addIdentifierType . } } } group by ?tgObject';

				request = {
					'query' : artefactQuery
				};
				return $.ajax({
			    type: 'GET',
			    url: "https://www.classicmayan.org/trip/metadata/query",
			    dataType: 'json',
			    async: false,
			    data: request
			  }).done(function(data) {

			    var addIdentifierName, addIdentifierType, i, id, idiomNumber, len, prefTitle, result, titleDisp, titleType;
			    results = data['results']['bindings'];
			    for (i = 0, len = results.length; i < len; i++) {
			      result = results[i];
						id = result['tgObjects']['value'];
				    if (typeof result['prefTitles'] === "undefined") {
				      prefTitle = "";
				    } else {
				      prefTitle = result['prefTitles']['value'];
				    }
				    if (typeof result['titleDisps'] === "undefined") {
				      titleDisp = "";
				    } else {
				      titleDisp = result['titleDisps']['value'];
				    }
				    if (typeof result['titleTypes'] === "undefined") {
				      titleType = "";
				    } else {
				      titleType = result['titleTypes']['value'];
				    }
				    if (typeof result['idiomNumbers'] === "undefined") {
				      idiomNumber = "";
				    } else {
				      idiomNumber = result['idiomNumbers']['value'];
				    }
				    if (typeof result['addIdentifierNames'] === "undefined") {
				      addIdentifierName = "";
				    } else {
				      addIdentifierName = result['addIdentifierNames']['value'];
				    }
				    if (typeof result['addIdentifierTypes'] === "undefined") {
				      addIdentifierType = "";
				    } else {
				      addIdentifierType = result['addIdentifierTypes']['value'];
				    }
						$('div#artefactResults').append('<div class="radio"> <label> <input type="radio" name="artefactRadios" value="' + id + '"> <strong>' + prefTitle + ": " + '</strong>' + ' Additional Title: ' + titleDisp + ' ( Title Type: ' + titleType + ')' + ', IDIOM-Number: ' + idiomNumber + ', Additional Identifier: ' + addIdentifierName + ' ( Identifier Type: ' + addIdentifierType + ') ' + '</label> </div>');
			    }
			    return results;
			  });

			});
	  </script>

		<script>
			var tgSID = "";
		  setSid = function(val) {
			  return tgSID = val;
		  };

			$(document).on("ready click", "button#parsetei", function(e) {

				var teiUri = $('input#teiUri').val();
				var artefactUri = $('input#artefactUri').val();
				var title = $('input#titleOfTEIFile').val();
				var tgSID = $('input#sid').val();
				$('textarea#teiParsingResult').val("wait for it");
				return $.ajax({
			    type: "GET",
			    url: "teiparser/parse?tei=" + teiUri + "&artefact=" + artefactUri.replace("http://textgridrep.de/", "textgrid:") + "&title=" + title + "&sid=" + tgSID,
			    mimeType: "text/xml",
			    cache: false,

					//data: encodeURIComponent(url),
			  }).done(function(data) {
							//console.log("testitest");
							//console.log(data);


							//var xmlTextNode = data.createTextNode(xmlText);
							//var parentDiv = data.getElementById('text');
							//parentDiv.appendChild(xmlTextNode);
							//var x = data.getElementsByTagName("ab")[0];
							var xmlText = new XMLSerializer().serializeToString(data);
							//console.log(x);
							//$('textarea#teiParsingResult').val(parentDiv);
							//$('textarea#teiParsingResult').val(xmlText);
							$('textarea#teiParsingResult').val(xmlText);
							//$('div.container-parserResults').append('<xmp><code class="lang-xml">' + xmlText + '</code></xmp>');
							var allABs = data.getElementsByTagName('ab').length;

							var allABsProceed = data.getElementsByTagName('ab');
							var counter=0;

							nodes = Array.prototype.slice.call(allABsProceed,0);

				   // nodes is an array now.
				   nodes.forEach(function(node){
						    var ab = nodes[counter];
						 		var xmlText = new XMLSerializer().serializeToString(ab);
								counter=counter+1;
								var blockid = ab.getAttribute('xml:id').toLowerCase();

								$("div.ab-parserResults").append('<div class="block" id="' + blockid + '">' +"</div>");
								$("div#" + blockid).append('<div class="blockID vertical-center" id=ab_' + blockid + '><h2 class="centerText">' + ab.getAttribute('xml:id') + '</h2></div>' );
								$("div#ab_" + blockid).after('<div class="boxABresult"><xmp>' + xmlText + '</div>');
								$("div#" + blockid).append('<div class="imageSigns"></div>');
								var allGlyphsForOneBlock = ab.getElementsByTagName('g');
								//console.log("GLPYHS: " + ab.getElementsByTagName('g').length);
								glphyNodes = Array.prototype.slice.call(allGlyphsForOneBlock,0);
								var counterGlyphs=0;

								glphyNodes.forEach(function(glphyNode){
										var refToSignImage = glphyNode.getAttribute('ref');

										if(refToSignImage!=null){
											//console.log("REFS: " + glphyNode.getAttribute('ref'));
											//console.log("FOUND IMAGE: " + refToSignImage.replace(/^\s+/g, ""));
											var uriToImage = getImageURI(refToSignImage);
                      //console.log("BLUBB: " + uriToImage.responseJSON.results.bindings[0]);
											if(typeof uriToImage.responseJSON.results.bindings[0] != "undefined"){
												uriToImage = uriToImage.responseJSON.results.bindings[0].image.value;
												//console.log(uriToImage);

												//console.log("URI IMAGE: " + uriToImage);
												var image="<img src=\"https://textgridlab.org/1.0/digilib/rest/IIIF/" + uriToImage.replace(/^\s+/g, "") + ';sid=' + tgSID + '/full/,60/0/native.jpg\" alt=\"\"/>'
												$("div#" + blockid + " div.imageSigns").append('<div class="imageSign">' + image + '</div>');
										}
										counterGlyphs++;
									}
								});
				   });
							//console.log(data);
							//var xmlDoc = data;
							//xmlDoc.getElementsByTagName("text");
							//console.log(xmlDoc);


							//var xml = $(data)
							//var results = $(data).find("#Bp2G1");
							//console.log(xml);
							//console.log(results);

				});
			});
			getImageURI = function(val) {

				        queryPrefixes = "prefix dct: <http://purl.org/dc/terms#> prefix dc: <http://purl.org/dc/elements/1.1/> prefix rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> prefix rdfs: <http://www.w3.org/2000/01/rdf-schema#> prefix owl: <http://www.w3.org/2002/07/owl#> prefix xsd: <http://www.w3.org/2001/XMLSchema#> prefix idi: <http://idiom.uni-bonn.de/terms#> prefix idiom: <http://idiom-projekt.de/schema/> prefix ecrm: <http://erlangen-crm.org/current#> prefix edm: <http://www.europeana.eu/schemas/edm#> prefix form: <http://rdd.sub.uni-goettingen.de/rdfform#> prefix crm: <http://erlangen-crm.org/current/> prefix tgforms: <http://www.tgforms.de/terms#> prefix textgrid: <http://textgridrep.de/> prefix schema: <http://schema.org/> prefix skos: <http://www.w3.org/2004/02/skos/core#> prefix wgs84pos: <http://www.w3.org/2003/01/geo/wgs84_pos#> prefix rel: <http://purl.org/vocab/relationship/> prefix edm: <http://www.europeana.eu/schemas/edm/> prefix idiomcat: <http://idiom-projekt.de/catalogue/>";
				request = {
					'query': queryPrefixes + 'SELECT ?graph ?tgURI ?image WHERE { GRAPH <' + val + '> { ?graph rdf:type idiomcat:Graph. ?graph idiomcat:hasDigitalImage ?image. } } '
				};
        //console.log(request.query)
				return $.ajax({
					type: 'GET',
					url: "https://www.classicmayan.org/trip/metadata/query",
					dataType: 'json',
					async: false,
					data: request
				}).done(function(data) {
					var i, imageURI;
			    results = data['results']['bindings'];

					for (i = 0, len = results.length; i < len; i++) {
						result = results[i];
						imageURI = result['image']['value'];
						console.log("HUHU " + val);
					}
					console.log("hatschi: " + JSON.stringify(imageURI));
					if(results[0]==undefined){
						return "false";
					}else{
						return JSON.stringify(results[0]["image"]["value"]);
					}

				});
				return imageURI;
			};
		</script>

    <script>
		$(document).on("ready click", "button#setArtefactURI", function(e) {
			id = $('div#artefactResults input[name="artefactRadios"]:checked').val();
			title = $('div#artefactResults input[name="artefactRadios"]:checked').next().text();
			if (id) {
				$('input#artefactUri').val(id)
				$('input#titleOfTEIFile').val(title.replace(":", ""))
			}
			$('div#artefactResults').empty();
			return $('div#artefactSearch-modal').modal('hide');
		});
		</script>
	</body>
</html>
